<!-- eslint-disable vue/no-mutating-props -->
<script setup lang="ts">
import type { Answers } from '@/types/Answers';
import type { Answer } from '@/types/Answer';
import AnswerButtons from './AnswerButtons.vue';
import SdgButton from './SdgButton.vue';
import correctResponses from '@/libs/correctResponses';
import { computed } from 'vue';
import howAboutAnother from '@/libs/howAboutAnother';
import { ForwardSlots } from 'vue-forward-slots';

const props = withDefaults(
  defineProps<{
    answers: Answers;
    completed?: boolean;
  }>(),
  { completed: false }
);

const emit = defineEmits(['onAnswerClick', 'onNext']);

const correctResponseLabel = correctResponses[Math.floor(Math.random() * correctResponses.length)];
const label = `${correctResponseLabel} ${howAboutAnother[Math.floor(Math.random() * howAboutAnother.length)]}`;

const onlyCorrectAnswer = computed(() => {
  const answers = {
    ...props.answers,
    answers: [{ ...(props.answers?.answers.find((answer) => answer.isCorrectAnswer) || {}) }]
  } as Answers;
  return answers;
});

async function onAnswerClick(answer: Answer): Promise<void> {
  emit('onAnswerClick', answer);
}

function onNext() {
  emit('onNext');
}
</script>
<template>
  <div class="flex flex-col">
    <div class="text-center">
      <transition mode="out-in" name="slide-right">
        <div v-if="completed" class="completed" key="completed">
          <ForwardSlots :slots="$slots">
            <AnswerButtons v-if="answers?.answers.length > 0" :answers="onlyCorrectAnswer" @onAnswerClick="onAnswerClick" />
          </ForwardSlots>
          <div class="text-center">
            <SdgButton v-if="completed" class="text-center max-w-96 mt-4" color="bg-sdg-blue" @onClick="onNext">
              <span>{{ label }}</span>
            </SdgButton>
          </div>
        </div>
        <div v-else key="incomplete">
          <ForwardSlots :slots="$slots">
            <AnswerButtons has-drawer :answers="props.answers" @onAnswerClick="onAnswerClick">
              <template #correctAnswerLabel>
                <span>{{ correctResponseLabel }}</span>
              </template>
            </AnswerButtons>
          </ForwardSlots>
        </div>
      </transition>
    </div>
  </div>
</template>

<style>
/* Enter and leave animations can use different */
/* durations and timing functions.              */
.slide-fade-enter-active {
  transition: all 0.8s cubic-bezier(1, 0.5, 0.8, 1);
}
.slide-fade-leave-active {
  transition: all 0.8s cubic-bezier(1, 0.5, 0.8, 1);
}
.slide-fade-enter, .slide-fade-leave-to
/* .slide-fade-leave-active below version 2.1.8 */ {
  transform: translateX(1000px);
  opacity: 0;
}

.slide-right-enter-active,
.slide-right-leave-active {
  transition: transform 0.3s ease-in-out;
}

.slide-right-enter-from,
.slide-right-leave-to {
  transform: translateX(100%);
}

.slide-right-enter-to,
.slide-right-leave-from {
  transform: translateX(0);
}
</style>
